/// <reference types="node" />
import { FSMergerObject, Node, FileMeta, FileMetaOption, FileContent, ProxyOperations } from './interface';
import { Options, Entry } from 'walk-sync';
declare class FSMerge {
    _dirList: Node[];
    MAP: {
        [key: string]: FSMergerObject;
    } | null;
    PREFIXINDEXMAP: {
        [key: number]: FSMergerObject;
    };
    _atList: FSMerge[];
    fs: ProxyOperations;
    constructor(trees: Node[] | Node);
    readFileSync(filePath: string, options?: {
        encoding?: string | null;
        flag?: string;
    } | string | null): FileContent | undefined;
    at(index: number): FSMerge;
    _generateMap(): void;
    readFileMeta(filePath: string, options: FileMetaOption): FileMeta | undefined;
    readdirSync(dirPath: string, options?: {
        encoding?: string | null;
        withFileTypes?: false;
    } | string | null): string[] | Buffer[];
    readdir(dirPath: string, options: {
        encoding?: string | null;
        withFileTypes?: false;
    } | string | undefined | null, callback: (err: NodeJS.ErrnoException | null, files: string[] | Buffer[]) => void): void;
    entries(dirPath: string | undefined, options: Options): Entry[];
}
export default FSMerge;
