/// <reference types="node" />
import { InputNode } from 'broccoli-node-api';
import { readFileSync, existsSync, lstatSync, statSync, readdirSync, readdir } from 'fs';
import { entries } from 'walk-sync';
declare type FSMergerObject = {
    root: string;
    prefix: string | undefined;
    getDestinationPath: Function | undefined;
};
declare type FileContent = string | Buffer | null;
declare type FileMeta = {
    path: string;
    prefix: string | undefined;
    getDestinationPath: Function | undefined;
};
declare type FileMetaOption = {
    basePath: string;
};
declare type Node = FSMergerObject | InputNode;
interface FSMerger {
    readFileSync: typeof readFileSync;
    readdirSync: typeof readdirSync;
    readdir: typeof readdir;
    at(index: number): FSMerger;
    readFileMeta(filePath: string, options: FileMetaOption): FileMeta;
    entries: typeof entries;
}
interface ProxyOperations extends FSMerger {
    existsSync: typeof existsSync;
    lstatSync: typeof lstatSync;
    statSync: typeof statSync;
}
export { FSMergerObject, Node, ProxyOperations, FileMeta, FileMetaOption, FileContent };
